## Built-in I/O tools

This page describes the built-in I/O tools:

- out

- err

- outln

- errln

### out tool

    tool out(string pattern, object?... args)

Prints formatted text (based on a pattern and arguments) to the standard output stream (stdout).

Parameters

`pattern`

  The format pattern.

`args`

  The arguments.

Runtime errors

- If the format pattern is invalid.

- If the format pattern and arguments don’t match.

### err tool

    tool err(string pattern, object?... args)

Prints formatted text (based on a pattern and arguments) to the standard error stream (stderr).

Parameters

`pattern`

  The format pattern.

`args`

  The arguments.

Runtime errors

- If the format pattern is invalid.

- If the format pattern and arguments don’t match.

### outln tool

    tool outln(string pattern = "", object?... args)

Prints formatted text (based on a pattern and arguments) to the standard output stream (stdout), printing an additional new line at the end.

Parameters

`pattern`

  The format pattern.

`args`

  The arguments.

Runtime errors

- If the format pattern is invalid.

- If the format pattern and arguments don’t match.

### errln tool

    tool errln(string pattern = "", object?... args)

Prints formatted text (based on a pattern and arguments) to the standard error stream (stderr), printing an additional new line at the end.

Parameters

`pattern`

  The format pattern.

`args`

  The arguments.

Runtime errors

- If the format pattern is invalid.

- If the format pattern and arguments don’t match.